import ols
from numpy.random import randn
import numpy
import gensim,logging
from gensim import corpora,models,similarities
import fileinput
import json
from pprint import pprint

id2word = gensim.corpora.Dictionary.load('tweets.dict')
lda = gensim.models.ldamodel.LdaModel.load('lda1.pkl')

y = numpy.zeros(1)
x = numpy.array([numpy.zeros(10)])
tweet = []
index = 1
for line in fileinput.input(['biz.json']):
	tweet = json.loads(line)
	if not tweet['retweet']:
		asciidata=tweet['text'].encode("ascii","ignore")
		if 'RT ' in asciidata:
			continue
		tweet_text = asciidata.replace('http', '').replace('.co', '')
		new_vec = id2word.doc2bow(tweet_text.lower().split())
		row = numpy.zeros(10)
		for topic in lda[new_vec]:
			row[int(topic[0])] = topic[1]
		x = numpy.vstack([x, row])
		y = numpy.append(y, int(tweet['retweet_count']))


x = x[1:x.shape[0],:]
y = y[1:y.shape[0]]
#print x
print numpy.sort(y)
print 'x shape: ', x.shape
print 'y shape: ', y.shape
mymodel = ols.ols(y, x , 'y', ['x1','x2','x3','x4','x5','x6','x7','x8','x9','x10'])
print mymodel.b
mymodel.summary()

sample_tweet = 'Great article about tech patents in the @nytimes. I am glad these issues are getting mainstream press. We need change. http://t.co/6QdzjbrO'
new_vec = id2word.doc2bow(sample_tweet.lower().split())
sample_x = lda[new_vec]
print sample_x
prediction = 0

row = numpy.zeros(10)
for topic in sample_x:
	row[int(topic[0])] = topic[1]

for index in range(1,9):
	prediction = prediction + (mymodel.b[index] * row[index-1])

prediction = prediction + mymodel.b[0]
print prediction

